unit nldlg32;

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes,
     Graphics, Controls, Forms, Dialogs, StdCtrls,
     ExtCtrls, Buttons;


Function MessageDlgPos(const Msg: String;
           AType: TMsgDlgType; Buttons: TMsgDlgButtons; HelpCtx: LongInt;
           X,Y: Integer): TModalResult;

Function MessageDlg(const Msg: String;
           AType: TMsgDlgType; Buttons: TMsgDlgButtons;
           HelpCtx: LongInt): TModalResult;

Function CustomMessageDlg(const Msg: String;
           const Title: String; AType: TMsgDlgType;
           dButtons: TMsgDlgButtons;
           HelpCtx: LongInt; X,Y: Integer): TModalResult;

function MessageDlgC(const Msg: string;
           AType: TMsgDlgType; Buttons: TMsgDlgButtons;
           HelpCtx: Longint): TModalResult;


var CenterDialogsOverMainForm: Boolean;

implementation



Function NLCreateMessage(const Msg: String;
           const Title: String; AType: TMsgDlgType;
           Buttons: TMsgDlgButtons; HelpCtx: LongInt;
           X,Y: Integer): TForm;
var i: integer;
begin
  Result := CreateMessageDialog(Msg,TMsgDlgType(AType),TMsgDlgButtons(Buttons));
  with Result do
  begin{with}
    if Title <> EmptyStr then Caption := Title;
    if X > -1 then Left := X;
    if Y > -1 then Top := Y;
    ScaleBy(Screen.PixelsPerInch,96);
    for i := 0 to ControlCount-1 do if Controls[i] is TButton then
    begin{for}
      if Pos('Yes',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := '&Ja';
      if Pos('No',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := '&Nee';
      if Pos('Cancel',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := '&Annuleer';
      if Pos('None',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := '&Geen';
      if Pos('Abort',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := 'Af&breken';
      if Pos('Retry',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := '&Opnieuw';
      if Pos('Ignore',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := 'Over&slaan';
      if Pos('All',TButton(Controls[i]).caption) > 0 then
         TButton(Controls[i]).Caption := 'A&lle(n)';
    end;{for}
  end{with}
end;


Function MessageDlgPos(const Msg: String;
           AType: TMsgDlgType; Buttons: TMsgDlgButtons;
           HelpCtx: LongInt; X,Y: Integer): TModalResult;
var Dlg: TForm;
    ATitle: String;
begin
  Case AType of
    mtWarning: ATitle := 'Waarschuwing';
    mtInformation: ATitle := 'Informatie';
    mtError: ATitle := 'Fout';
    mtConfirmation: ATitle := 'Bevestiging';
  end;
  Dlg := NlCreateMessage(Msg,ATitle,AType,Buttons,HelpCtx,X,Y);
  Result := Dlg.ShowModal;
  Dlg.Free;
end;

Function MessageDlg(const Msg: String;
           AType: TMsgDlgType; Buttons: TMsgDlgButtons;
           HelpCtx: LongInt): TModalResult;
//Dialoog wordt standaard gecentreerd t.o.v. Screen object
begin
  if CenterDialogsOverMainForm then
    Result := MessageDlgC(Msg,AType,Buttons,HelpCtx)
  else
    Result := MessageDlgPos(Msg,AType,Buttons,HelpCtx,-1,-1);
end;


function MessageDlgC(const Msg: string; AType: TMsgDlgType;
       Buttons: TMsgDlgButtons; HelpCtx: Longint): TModalResult;
//Centreer MessageDlg t.o.v. Application.MainForm (i.p.v. t.o.v. Screen object)
//Dank aan Matthijs Willemstein (op HCC PGG Delphi Forum)
var
  Dlg: TForm;
  ATop, ALeft, AWidth, AHeight: Integer;
  ATitle: String;
begin
  Case AType of
    mtWarning: ATitle := 'Waarschuwing';
    mtInformation: ATitle := 'Informatie';
    mtError: ATitle := 'Fout';
    mtConfirmation: ATitle := 'Bevestiging';
  end;
  Dlg := NlCreateMessage(Msg,ATitle,AType,Buttons,HelpCtx,-1,-1);
  if Application.MainForm <> nil then
  begin
    ATop := Application.MainForm.Top;
    ALeft := Application.MainForm.Left;
    AHeight := Application.MainForm.Height;
    AWidth := Application.MainForm.Width;
    Dlg.Top := ATop + (AHeight - Dlg.Height) div 2;
    Dlg.Left := ALeft + (AWidth - Dlg.Width) div 2;
    //Houdt dialoog zichtbaar
    if Dlg.Left + Dlg.Width > Screen.Width then Dlg.Left := Screen.Width - Dlg.Width;
    if Dlg.Top + Dlg.Height > Screen.Height then Dlg.Top := Screen.Height - Dlg.Height;
    if Dlg.Left < 0 then Dlg.Left := 0;
    if Dlg.Top < 0 then Dlg.Top := 0;
  end;
  Result := Dlg.ShowModal;
  Dlg.Free;
end;


Function CustomMessageDlg(const Msg: String;
           const Title: String; AType: TMsgDlgType;
           dButtons: TMsgDlgButtons;
           HelpCtx: LongInt; X,Y: Integer): TModalResult;
var ATitle: String;
    Dlg: TForm;
begin
  if Title = EmptyStr then
  begin
    Case AType of
      mtWarning: ATitle := 'Waarschuwing';
      mtInformation: ATitle := 'Informatie';
      mtError: ATitle := 'Fout';
      mtConfirmation: ATitle := 'Bevestiging';
    end;
  end
  else ATitle := Title;
  Dlg := NlCreateMessage(Msg,ATitle,AType,dButtons,HelpCtx,X,Y);
  Result := Dlg.ShowModal;
  Dlg.Free;
end;




(*
//Eigen brouwsel ...


function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

function _MessageDlgC(const Msg: string; DlgType: TMsgDlgType;
       Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
//Centreer MessageDlg t.o.v. Application.MainForm (i.p.v. t.o.v. Screen object)
var X, Y, CX, CY,
    DialogWidth, THeight, DialogHeight, ButtonWidth, ButtonSpacing,
    ButtonHeight, ButtonCount, HorMargin, VertMargin, VertSpacing, LFC, i: Integer;
    B: TMsgDlgBtn;
    P: TPoint;
begin
  //Default: centreer t.o.v. Screen
  X := -1;
  Y := -1;
  if Application.MainForm <> nil then
  begin
    CX := Application.MainForm.Left + (Application.MainForm.Width div 2);
    CY := Application.MainForm.Top + (Application.MainForm.Height div 2);

    P := GetAveCharSize(Application.Mainform.Canvas);
    //Button width, zie Dialogs.pas
    ButtonWidth := MulDiv(50, P.X, 4);

    //ButtonCount
    ButtonCount := 0;
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
      if B in Buttons then Inc(ButtonCount);

    //Button spacing
    ButtonSpacing := MulDiv(5, P.X, 4);

    //Horizontale, Verticale marge en verticale spacing
    HorMargin := MulDiv(8, P.X, 4);
    VertMargin := MulDiv(8, P.Y, 8);
    VertSpacing := MulDiv(10, P.Y, 8);


    //Breedte MessageDlg bij benadering
    DialogWidth := Application.MainForm.Canvas.TextWidth(Msg) + HorMargin * 2 {Marge} + 10 {compensatie voor border};
    //Meer buttons dan tekst ?
    if DialogWidth < (ButtonCount * ButtonWidth + ((ButtonCount - 1) * ButtonSpacing) + 2 * HorMargin) then
      DialogWidth := ButtonCount * ButtonWidth  + (ButtonCount - 1) * ButtonSpacing + 2 * HorMargin;

    //Button hoogte
    ButtonHeight := MulDiv(14, P.Y , 8);

    LFC := 1;
    //Hoeveel regels in Msg ?
    for i := 1 to Length(Msg) do if (Msg[i] = ^m) then Inc(LFC);

    //Hoogte MessgeDlg bij benadering
    THeight := Application.MainForm.Canvas.TextHeight(Msg) * LFC;
    //TextHeight < icoontje in dialoog ?
    if THeight < 32 then THeight := 32;
    DialogHeight := THeight + 2 * VertMargin + ButtonHeight + VertSpacing + 10 {compensatie voor borders};

    //Left en Top van MessageDlg
    X := CX - (DialogWidth div 2);
    Y := CY - (DialogHeight div 2) ;

    //Houdt dialoog zichtbaar
    if X + DialogWidth > Screen.Width then X := Screen.Width - DialogWidth;
    if Y + DialogHeight > Screen.Height then Y := Screen.Height - DialogHeight;
    if X < 0 then X := 0;
    if Y < 0 then Y := 0;
  end;
  Result := MessageDlgPos(Msg,mtInformation,Buttons,HelpCtx,X,Y);
end;
*)



Initialization
  CenterDialogsOverMainForm := True;
end.
